

import java.sql.*;
import java.util.*;
import java.io.*;

/*
 * GET ALL EMPLOYEE: legge tutti gli Employee contenuti nel DB
 */

public final class GetAllEmployee
{
  String url = "jdbc:oracle:thin:@brucaliffo:1521:ORADB";
  String user = "scott";
  String pass = "tiger";

  /*
   *  Singleton 
   */
  public static GetAllEmployee getInstance()
  {
    return new GetAllEmployee();
  }
  
  /*
   *  Restituisce la Type Map 
   */
  final Hashtable getMap()
  {
    Hashtable map = new Hashtable();
    
	map.put("O_EMPLOYEE", EmployeeWrap.class);
    return map;
  }
 
  /*
   *  Main 
   */
  public static final void main(String[] args)
  {
        
	try
	{
    	GetAllEmployee.getInstance().executeCrs("{? = call P_TEST.get_employee()}", "O_EMPLOYEE");	
	}
    

		catch (SQLException sqle)
		{
		  sqle.printStackTrace();
		}
		catch(Exception e)
		{
		  e.printStackTrace();
		}
   
  }
  
  /*
   *  Chiama la Stored Procedure
   */
  public final void executeCrs(String procedure, String type) throws Exception
  {
      
  	DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
  	
  	Connection conn = DriverManager.getConnection(url, user, pass);
  	
  	oracle.jdbc.driver.OracleCallableStatement statement = (oracle.jdbc.driver.OracleCallableStatement)conn.prepareCall
  	(
  	  conn.nativeSQL(procedure)
  	);
	
	System.out.println("PROCEDURE : " + procedure);
	System.out.println("TYPE : " + type);
	
	statement.registerOutParameter(1, oracle.jdbc.driver.OracleTypes.CURSOR);
  		 
  	statement.execute();
  	
    Map map = com.acme.resource.ResourceManager.getInstance().getMap();
   
   oracle.jdbc.driver.OracleResultSet rs = null;
   
   statement.executeQuery();
   
   rs = 
   (oracle.jdbc.driver.OracleResultSet)statement.getCursor(1);
    
  Wrapper wrap = null;

  while(rs.next())
  {
    wrap = (Wrapper) rs.getObject(1, map);
  	System.out.println(Snoopy.snoop(wrap.getWrappedObj()));
  }
   
    statement.close();
    conn.close();
    
  }
 
}