
import java.sql.*;
import java.util.*;
import java.io.*;

/*
 * SET Department: scrive un oggetto di tipo Department nel DB
 */


public final class SetDepartment
{
  String url = "jdbc:oracle:thin:@brucaliffo:1521:ORADB";
  String user = "scott";
  String pass = "tiger";
  
  /*
   *  Costruttore 
   */
  public static SetDepartment getInstance()
  {
    return new SetDepartment();
  }
  
  
 /*
  *  Restituisce la Type Map 
  */
  final Hashtable getMap()
  {
    Hashtable map = new Hashtable();
    
	map.put("O_DEPARTMENT", DepartmentWrap.class);
	map.put("O_EMPLOYEE", EmployeeWrap.class);	
    return map;
  }
  
  
  /*
   *  Main 
   */
    public static final void main(String[] args)
  {
        
	try
	{
		  
    	SetDepartment.getInstance().execute("{call P_TEST.set_department(?)}", "O_DEPARTMENT");	
	}
    

		catch (SQLException sqle)
		{
		  sqle.printStackTrace();
		}
		catch(Exception e)
		{
		  e.printStackTrace();
		}
   
  }
  
  /*
   *  Chiama la Stored Procedure
   */
  public final void execute(String procedure, String type) throws Exception
  {
      
    DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
    
	//connessione
    Connection conn = DriverManager.getConnection(url, user, pass);
    Hashtable map = SetDepartment.getInstance().getMap();
    conn.setTypeMap(map);
    
	//statement
    CallableStatement statement = conn.prepareCall
    (
      conn.nativeSQL(procedure)
    );
    
    System.out.println("PROCEDURE : " + procedure);
    System.out.println("TYPE : " + type);
	
	// registrazione parametri di IN ed OUT
	
	Employee[] emps = new Employee[2];
	emps[0] = new Employee(-1, "NAME 0", "JOB", 5, new java.sql.Date(System.currentTimeMillis()), 0.00D, 2D, -1);
	emps[1] = new Employee(-1, "NAME 1", "JOB", 5, new java.sql.Date(System.currentTimeMillis()), 0.00D, 2D, -1);	
	Department the_dep = new Department(-1, "DEPT NAME", "ROME", emps);
	
	statement.setObject(1, new DepartmentWrap(the_dep));
	statement.registerOutParameter(1, oracle.jdbc.driver.OracleTypes.STRUCT, type);
			 
    statement.execute();
    
    // legge la Primary Key assegnata all'oggetto 
    the_dep = (Department)((Wrapper)statement.getObject(1, map)).getWrappedObj();
	
    statement.close();
    conn.close();
    
	System.out.println(Snoopy.snoop(the_dep));
	
  }
  
 
}