
import java.sql.*;
import java.util.*;
import java.io.*;

/*
 * SET EMPLOYEE: scrive un oggetto di tipo Employee nel DB
 */


public final class SetEmployee
{
  String url = "jdbc:oracle:thin:@brucaliffo:1521:ORADB";
  String user = "scott";
  String pass = "tiger";
  
  /*
   *  Costruttore 
   */
  public static SetEmployee getInstance()
  {
    return new SetEmployee();
  }
  
  
 /*
  *  Restituisce la Type Map 
  */
  final Hashtable getMap()
  {
    Hashtable map = new Hashtable();
    
	map.put("O_EMPLOYEE", EmployeeWrap.class);
    return map;
  }
  
  
  /*
   *  Main 
   */
    public static final void main(String[] args)
  {
        
	try
	{
		  
    	SetEmployee.getInstance().execute("{? = call P_TEST.set_employee(?)}", "O_EMPLOYEE");	
		// Controlliamo se nella lista degli aggiunti ci sia anche il nostro
		GetAllEmployee.main(null);
	}
    

		catch (SQLException sqle)
		{
		  sqle.printStackTrace();
		}
		catch(Exception e)
		{
		  e.printStackTrace();
		}
   
  }
  
  /*
   *  Chiama la Stored Procedure
   */
  public final void execute(String procedure, String type) throws Exception
  {
      
    DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
    
	//connessione
    Connection conn = DriverManager.getConnection(url, user, pass);
    Hashtable map = SetEmployee.getInstance().getMap();
    conn.setTypeMap(map);
    
	//statement
    CallableStatement statement = conn.prepareCall
    (
      conn.nativeSQL(procedure)
    );
    
    System.out.println("PROCEDURE : " + procedure);
    System.out.println("TYPE : " + type);
	
	// registrazione parametri di IN ed OUT
	Employee the_emp = new Employee(-1, "NAME", "JOB", 5, new java.sql.Date(System.currentTimeMillis()), 0.00D, 2D, 10);
	statement.setObject(2, new EmployeeWrap(the_emp));
	statement.registerOutParameter(1, Types.NUMERIC);
			 
    statement.execute();
    
    // legge la Primary Key assegnata all'oggetto 
    long pk = statement.getLong(1);
	the_emp.empno = pk;
    
	System.out.println("PK : " + pk);
	
    statement.close();
    conn.close();
  }
  
 
}